Core Library 1.7.0.0 Library containing core utilities and tools for threading, networking, logging, INI and CSV file management etc.

Public Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
core_lib::asio::tcp::TcpClientList Class Referencefinal

A class implementing a collection of bi-directional TCP clients. More...

`#include <TcpClientList.h>`

## Public Member Functions
| TcpClientList ()=delete
| Default constructor - deleted.
| TcpClientList (TcpClientList const &)=delete
| Copy constructor - deleted.
TcpClientList & | operator= (TcpClientList const &)=delete
| Copy assignment operator - deleted.
| TcpClientList (TcpClientList &&)=delete
| Move constructor - deleted.
TcpClientList & | operator= (TcpClientList &&)=delete
| Move assignment operator - deleted.
| TcpClientList (boost_iocontext_t &ioContext, size_t minAmountToRead, defs::check_bytes_left_to_read_t const &checkBytesLeftToRead, defs::message_received_handler_t const &messageReceivedHandler, eSendOption sendOption=eSendOption::nagleOn, size_t maxAllowedUnsentAsyncMessages=MAX_UNSENT_ASYNC_MSG_COUNT)
| Initialisation constructor. More...
| TcpClientList (size_t minAmountToRead, defs::check_bytes_left_to_read_t const &checkBytesLeftToRead, defs::message_received_handler_t const &messageReceivedHandler, eSendOption sendOption=eSendOption::nagleOn, size_t maxAllowedUnsentAsyncMessages=MAX_UNSENT_ASYNC_MSG_COUNT)
| Initialisation constructor. More...
| ~TcpClientList ()
| Default destructor.
defs::connection_t | ServerConnection (defs::connection_t const &clientConn) const
| Retrieve server connection details for a client. More...
bool | Connected (defs::connection_t const &server) const
| Check if the client is connected to the server. More...
defs::connection_t | GetClientDetailsForServer (defs::connection_t const &server) const
| Retrieve this client's connection details. More...
void | CloseConnection (defs::connection_t const &server) const
| Manually close the client's connection. More...
void | CloseConnections () const
| Manually close the all client connections. More...
void | ClearConnections ()
| Destroy all TCP clients and clear map.
bool | SendMessageToServerAsync (defs::connection_t const &server, defs::char_buffer_t const &message)
| Send a message buffer to the server asynchronously. More...
bool | SendMessageToServerSync (defs::connection_t const &server, defs::char_buffer_t const &message)
| Send a message buffer to the server synchronously. More...
void | ClearList ()
| Clear all TCP clients from list.
std::vector< defs::connection_t > | GetServerList () const
| Get list of connections. More...
size_t | NumberOfUnsentAsyncMessages (const defs::connection_t &server) const
| Get number of unsent async messages. More...

## Private Types
using | client_ptr_t = std::shared_ptr< TcpClient >
using | client_map_t = std::map< defs::connection_t, client_ptr_t >

## Private Member Functions
client_ptr_t | CreateTcpClient (defs::connection_t const &server)
| Create the client connection for the server. More...
client_ptr_t | FindTcpClient (defs::connection_t const &server) const
| Find the client connection for the server. More...

## Private Attributes
std::mutex | m_mutex
| Mutex to make access to map thread safe.
boost_iocontext_t * | m_ioContextPtr {nullptr}
| External boost IO context to manage ASIO.
size_t | m_minAmountToRead {0}
| Minimum amount of data to read on each receive, typical size of header block.
defs::check_bytes_left_to_read_t | m_checkBytesLeftToRead {}
| Function object capable of decoding the message and computing how many bytes are left until a complete message.
defs::message_received_handler_t | m_messageReceivedHandler {}
| Function object cpable of handling a received message and disptaching it accordingly.
eSendOption | m_sendOption {eSendOption::nagleOn}
| Socket send option to control the use of the Nagle algorithm.
size_t | m_maxAllowedUnsentAsyncMessages {MAX_UNSENT_ASYNC_MSG_COUNT}
| Max allowed unsent async message counter.
client_map_t | m_clientMap {}
| Map of TCP clients.

## Detailed Description

A class implementing a collection of bi-directional TCP clients.

## Constructor & Destructor Documentation

## ◆ TcpClientList() [1/2]

core_lib::asio::tcp::TcpClientList::TcpClientList | ( | boost_iocontext_t & | ioContext,
|  | size_t | minAmountToRead,
|  | defs::check_bytes_left_to_read_t const & | checkBytesLeftToRead,
|  | defs::message_received_handler_t const & | messageReceivedHandler,
|  | eSendOption | sendOption = `eSendOption::nagleOn`,
|  | size_t | maxAllowedUnsentAsyncMessages = `MAX_UNSENT_ASYNC_MSG_COUNT`
| ) |  |

Initialisation constructor.

Parameters

  [in] | ioContext | - External boost IO context to manage ASIO.
  [in] | minAmountToRead | - Minimum amount of data to read on each receive, typical size of header block.
  [in] | checkBytesLeftToRead | - Function object capable of decoding the message and computing how many bytes are left until a complete message.
  [in] | messageReceivedHandler | - Function object capable of handling a received message and dispatching it accordingly.
  [in] | sendOption | - Socket send option to control the use of the Nagle algorithm.
  [in] | maxAllowedUnsentAsyncMessages | - Maximum allowed number of unsent async messages.

Typically use this constructor when managing a bool of threads using an instance of core_lib::asio::IoContextThreadGroup in your application to manage a pool of std::threads. This means you can use a single thread pool and all ASIO operations will be executed using this thread pool managed by a single IO context. This is the recommended constructor.

## ◆ TcpClientList() [2/2]

core_lib::asio::tcp::TcpClientList::TcpClientList | ( | size_t | minAmountToRead,
|  | defs::check_bytes_left_to_read_t const & | checkBytesLeftToRead,
|  | defs::message_received_handler_t const & | messageReceivedHandler,
|  | eSendOption | sendOption = `eSendOption::nagleOn`,
|  | size_t | maxAllowedUnsentAsyncMessages = `MAX_UNSENT_ASYNC_MSG_COUNT`
| ) |  |

Initialisation constructor.

Parameters

  [in] | minAmountToRead | - Minimum amount of data to read on each receive, typical size of header block.
  [in] | checkBytesLeftToRead | - Function object capable of decoding the message and computing how many bytes are left until a complete message.
  [in] | messageReceivedHandler | - Function object capable of handling a received message and dispatching it accordingly.
  [in] | sendOption | - Socket send option to control the use of the Nagle algorithm.
  [in] | maxAllowedUnsentAsyncMessages | - Maximum allowed number of unsent async messages.

This constructor does not require an external IO context to run instead it creates its own IO context object along with its own thread. For very simple cases this version will be fine but in more performance and resource critical situations the external IO context constructor is recommended.

## Member Function Documentation

## ◆ CloseConnection()

void core_lib::asio::tcp::TcpClientList::CloseConnection | ( | defs::connection_t const & | server | ) | const

Manually close the client's connection.

Parameters

  [in] | server | - Connection object describing server's address and port.

Note that this object uses RAII so will close all connections when destroyed.

## ◆ CloseConnections()

void core_lib::asio::tcp::TcpClientList::CloseConnections | ( |  | ) | const

Manually close the all client connections.

Note that this object uses RAII so will close all connections when destroyed.

## ◆ Connected()

bool core_lib::asio::tcp::TcpClientList::Connected | ( | defs::connection_t const & | server | ) | const

Check if the client is connected to the server.

Parameters

  [in] | server | - Connection object describing server's address and port.

Returns
  True if connected, false otherwise.

## ◆ CreateTcpClient()

auto core_lib::asio::tcp::TcpClientList::CreateTcpClient | ( | defs::connection_t const & | server | ) |
| private

Create the client connection for the server.

Parameters

  [in] | server | - Connection object describing server's address and port.

Returns
  A std::shared_ptr to a TcpClient or a null pointer of not found.

## ◆ FindTcpClient()

auto core_lib::asio::tcp::TcpClientList::FindTcpClient | ( | defs::connection_t const & | server | ) | const
| private

Find the client connection for the server.

Parameters

  [in] | server | - Connection object describing server's address and port.

Returns
  A std::shared_ptr to a TcpClient or a null pointer of not found.

## ◆ GetClientDetailsForServer()

auto core_lib::asio::tcp::TcpClientList::GetClientDetailsForServer | ( | defs::connection_t const & | server | ) | const

Retrieve this client's connection details.

Parameters

  [in] | server | - Connection object describing server's address and port.

Returns
  Connection object describing this client's address and port.

Throws xUnknownConnectionError is remoteEnd is not valid.

## ◆ GetServerList()

auto core_lib::asio::tcp::TcpClientList::GetServerList | ( |  | ) | const

Get list of connections.

Returns
  - list of server connection details.

## ◆ NumberOfUnsentAsyncMessages()

size_t core_lib::asio::tcp::TcpClientList::NumberOfUnsentAsyncMessages | ( | const defs::connection_t & | server | ) | const

Get number of unsent async messages.

Parameters

  [in] | server | - Target connection details.

Returns
  Number of unsent messages

## ◆ SendMessageToServerAsync()

bool core_lib::asio::tcp::TcpClientList::SendMessageToServerAsync | ( | defs::connection_t const & | server,
|  | defs::char_buffer_t const & | message
| ) |  |

Send a message buffer to the server asynchronously.

Parameters

  [in] | server | - Connection object describing server's address and port.
  [in] | message | - Message buffer.

Returns
  True if sent successfully, false otherwise.

## ◆ SendMessageToServerSync()

bool core_lib::asio::tcp::TcpClientList::SendMessageToServerSync | ( | defs::connection_t const & | server,
|  | defs::char_buffer_t const & | message
| ) |  |

Send a message buffer to the server synchronously.

Parameters

  [in] | server | - Connection object describing server's address and port.
  [in] | message | - Message buffer.

Returns
  Returns the success state of the send as a boolean.

## ◆ ServerConnection()

auto core_lib::asio::tcp::TcpClientList::ServerConnection | ( | defs::connection_t const & | clientConn | ) | const

Retrieve server connection details for a client.

Parameters

  [in] | clientConn | - Connection object describing server's address and port.

Returns
  - Connection object describing target server's address and port.

The documentation for this class was generated from the following files:

- D:/Projects/CoreLibrary/Include/Asio/TcpClientList.h
- D:/Projects/CoreLibrary/Source/Asio/TcpClientList.cpp